Index: src/main/java/com/example/rezevirajmasa/demo/service/impl/RestaurantServiceImpl.java
===================================================================
--- src/main/java/com/example/rezevirajmasa/demo/service/impl/RestaurantServiceImpl.java	(revision e48199adf103ea72701a91722bdbf8cfb9732731)
+++ src/main/java/com/example/rezevirajmasa/demo/service/impl/RestaurantServiceImpl.java	(revision d24f17cb212e43f94a77a44d655ba10b4b8143d2)
@@ -1,22 +1,15 @@
 package com.example.rezevirajmasa.demo.service.impl;
 
-import com.example.rezevirajmasa.demo.dto.ReservationDTO;
-import com.example.rezevirajmasa.demo.dto.RestaurantDTO;
-import com.example.rezevirajmasa.demo.dto.TableDTO;
-import com.example.rezevirajmasa.demo.model.Reservation;
 import com.example.rezevirajmasa.demo.model.Restaurant;
 import com.example.rezevirajmasa.demo.model.TableEntity;
-import com.example.rezevirajmasa.demo.model.User;
 import com.example.rezevirajmasa.demo.model.exceptions.InvalidRestaurantIdException;
 import com.example.rezevirajmasa.demo.repository.RestaurantRepository;
 import com.example.rezevirajmasa.demo.repository.TableRepository;
-import com.example.rezevirajmasa.demo.service.ReservationService;
 import com.example.rezevirajmasa.demo.service.RestaurantService;
 import com.example.rezevirajmasa.demo.service.TableService;
 import com.sun.tools.jconsole.JConsoleContext;
 import jakarta.transaction.Transactional;
-import org.openqa.selenium.InvalidArgumentException;
 import org.springframework.stereotype.Service;
-import org.modelmapper.ModelMapper;
+
 import java.time.LocalDate;
 import java.time.LocalDateTime;
@@ -38,42 +31,13 @@
     private final TableRepository tableRepository;
     private final TableService tableService;
-    private final ReservationService reservationService;
-    private ModelMapper modelMapper = new ModelMapper();
 
-    public RestaurantServiceImpl(RestaurantRepository restaurantRepository, TableRepository tableRepository, TableService tableService, ReservationService reservationService) {
+    public RestaurantServiceImpl(RestaurantRepository restaurantRepository, TableRepository tableRepository, TableService tableService) {
         this.restaurantRepository = restaurantRepository;
         this.tableRepository = tableRepository;
         this.tableService = tableService;
-        this.reservationService = reservationService;
     }
 
     @Override
-    public List<RestaurantDTO> listall() {
-        List<Restaurant> restaurants = restaurantRepository.findAll();
-
-        List<RestaurantDTO> restaurantDTOS = new ArrayList<>();
-
-        for (Restaurant restaurant : restaurants) {
-            RestaurantDTO restaurantDTO = modelMapper.map(restaurant, RestaurantDTO.class);
-            List<TableDTO> tableDTOS = new ArrayList<>();
-            for (TableEntity table : restaurant.getTablesList()) {
-                TableDTO tableDTO = modelMapper.map(table, TableDTO.class);
-                List<ReservationDTO> reservationDTOS = new ArrayList<>();
-                for (Reservation reservation : table.getReservations()) {
-                    ReservationDTO reservationDTO = modelMapper.map(reservation, ReservationDTO.class);
-
-                    reservationDTOS.add(reservationDTO);
-                }
-                tableDTO.setReservations(reservationDTOS);
-                tableDTOS.add(tableDTO);
-            }
-            restaurantDTO.setTablesList(tableDTOS);
-            restaurantDTOS.add(restaurantDTO);
-        }
-        return restaurantDTOS;
-    }
-
-    @Override
-    public List<Restaurant> listAll() {
+    public List<Restaurant> listall() {
         return restaurantRepository.findAll();
     }
@@ -87,8 +51,4 @@
     @Override
     public void save(Restaurant restaurant, int numberOfTables, List<Integer> tableCapacities, List<String> tableLocations, List<String> tableSmokingAreas, List<String> tableDescriptions) {
-        if (numberOfTables != tableCapacities.size() || numberOfTables != tableLocations.size() || numberOfTables != tableSmokingAreas.size() || numberOfTables != tableDescriptions.size()) {
-            throw new IllegalArgumentException("Mismatched table data. Number of tables does not match the size of the input lists.");
-        }
-
         restaurantRepository.save(restaurant);
         String[] hours = restaurant.getOperatingHours().split("-");
@@ -100,12 +60,19 @@
             LocalTime startTime = LocalTime.parse(hours[0], DateTimeFormatter.ofPattern("HH:mm"));
             LocalTime endTime = LocalTime.parse(hours[1], DateTimeFormatter.ofPattern("HH:mm"));
+            System.out.println("IsBefore: " + startTime.isBefore(endTime) + " and equals: " + startTime.equals(endTime));
 
             for (int i = 0; i < numberOfTables; i++) {
                 TableEntity table = new TableEntity();
+
+//                table.initializeTimeSlots(startTime, endTime);
+
                 table.setCapacity(tableCapacities.get(i));
-                table.setTableLocation(tableLocations.get(i));
-                table.setSmokingArea(tableSmokingAreas.get(i).equalsIgnoreCase("on"));
+                table.setLocation(tableLocations.get(i));
+
+                String smokingAreaString = tableSmokingAreas.get(i);
+                table.setSmokingArea(smokingAreaString.equalsIgnoreCase("on"));
                 table.setDescription(tableDescriptions.get(i));
                 table.setRestaurant(restaurant);
+
                 tableRepository.save(table);
             }
@@ -117,34 +84,7 @@
     }
     @Override
-    public RestaurantDTO findById(Long restaurantId) {
-        Restaurant restaurant = restaurantRepository.findById(restaurantId)
-                .orElseThrow(InvalidRestaurantIdException::new);
-
-        RestaurantDTO restaurantDTO = modelMapper.map(restaurant, RestaurantDTO.class);
-
-        List<TableDTO> tableDTOS = new ArrayList<>();
-        for (TableEntity table : restaurant.getTablesList()) {
-            TableDTO tableDTO = modelMapper.map(table, TableDTO.class);
-
-            List<ReservationDTO> reservationDTOS = new ArrayList<>();
-            for (Reservation reservation : table.getReservations()) {
-                ReservationDTO reservationDTO = modelMapper.map(reservation, ReservationDTO.class);
-                reservationDTOS.add(reservationDTO);
-            }
-
-            tableDTO.setReservations(reservationDTOS);
-            tableDTOS.add(tableDTO);
-        }
-
-        restaurantDTO.setTablesList(tableDTOS);
-
-        return restaurantDTO;
+    public Restaurant findById(Long restaurantId) {
+        return restaurantRepository.findById(restaurantId).orElseThrow(InvalidRestaurantIdException::new);
     }
-
-    @Override
-    public Restaurant findByIdRestaurant(Long restaurantId) {
-        return restaurantRepository.findById(restaurantId).orElseThrow(()-> new InvalidArgumentException("No restaurant with provided id"));
-    }
-
 
     @Override
@@ -175,4 +115,5 @@
     @Override
     public List<Restaurant> listRestaurantBy(String search) {
+        // Get all restaurants from the repository
         List<Restaurant> allRestaurants = restaurantRepository.findAll();
 
@@ -193,4 +134,5 @@
 
         for (Restaurant restaurant : restaurants) {
+            // Check if the restaurant has available time slots for today
             boolean hasAvailableTimeSlots = tableService.hasAvailableTimeSlotsForRestaurantAndDate(restaurant, today);
             if (hasAvailableTimeSlots) {
@@ -201,72 +143,3 @@
         return restaurantsWithAvailableTimeSlots;
     }
-
-    @Override
-    public List<Restaurant> findRestaurantsByDateTimeAndPartySize(LocalDateTime dateTime, int partySize, String search) {
-        LocalDateTime checkOutTime = dateTime.plusHours(2);
-        List<Restaurant> allRestaurants = restaurantRepository.findAll();
-
-        return allRestaurants.stream()
-                .filter(restaurant -> restaurant.getTablesList().stream()
-                        .anyMatch(table -> tableRepository.findAvailableTables(dateTime, checkOutTime, partySize)
-                                .contains(table)))
-                .filter(restaurant -> isMatch(restaurant, search))
-                .collect(Collectors.toList());
-    }
-
-    private boolean isMatch(Restaurant restaurant, String name) {
-        return name == null || name.isEmpty() || restaurant.getName().contains(name);
-    }
-
-    @Override
-    public List<RestaurantDTO> findRestaurantsBySearchParams(LocalDateTime dateTime, int partySize, String search) {
-        List<Restaurant> availableRestaurants = new ArrayList<>();
-
-        List<Restaurant> restaurantList;
-        if (search == null || search.isEmpty()) {
-            restaurantList = restaurantRepository.findAll();
-        } else {
-            String searchTerm = "%" + search + "%";
-            restaurantList = restaurantRepository.findAllByNameLikeIgnoreCase(searchTerm);
-
-            if (restaurantList.isEmpty()) {
-                restaurantList = restaurantRepository.findAllByCuisineTypeContaining(search);
-            }
-        }
-
-        for (Restaurant restaurant : restaurantList) {
-            boolean hasAvailableTable = restaurant.getTablesList().stream()
-                    .anyMatch(table -> table.isAvailable(dateTime, partySize));
-
-            if (hasAvailableTable) {
-                availableRestaurants.add(restaurant);
-            }
-        }
-
-        List<RestaurantDTO> restaurantDTOS = availableRestaurants.stream().map(this::convertToDto).toList();
-        return restaurantDTOS;
-    }
-
-    @Override
-    public List<String> findALlCuisineTypes() {
-        return restaurantRepository.findAllCuisineTypes();
-    }
-
-    @Override
-    public List<RestaurantDTO> findRestaurantsByCuisineType(String param) {
-        List<Restaurant> restaurants = restaurantRepository.findAllByCuisineType(param);
-        return restaurants.stream().map(this::convertToDto).toList();
-    }
-
-    public RestaurantDTO convertToDto(Restaurant restaurant) {
-        return modelMapper.map(restaurant, RestaurantDTO.class);
-    }
-
-    public TableDTO convertToDto(TableEntity table) {
-        return modelMapper.map(table, TableDTO.class);
-    }
-
-    public ReservationDTO convertToDto(Reservation reservation) {
-        return modelMapper.map(reservation, ReservationDTO.class);
-    }
 }
Index: src/main/java/com/example/rezevirajmasa/demo/service/impl/TableServiceImpl.java
===================================================================
--- src/main/java/com/example/rezevirajmasa/demo/service/impl/TableServiceImpl.java	(revision e48199adf103ea72701a91722bdbf8cfb9732731)
+++ src/main/java/com/example/rezevirajmasa/demo/service/impl/TableServiceImpl.java	(revision d24f17cb212e43f94a77a44d655ba10b4b8143d2)
@@ -1,18 +1,11 @@
 package com.example.rezevirajmasa.demo.service.impl;
 
-import com.example.rezevirajmasa.demo.dto.ReservationDTO;
-import com.example.rezevirajmasa.demo.dto.RestaurantDTO;
-import com.example.rezevirajmasa.demo.dto.TableDTO;
-import com.example.rezevirajmasa.demo.model.Reservation;
 import com.example.rezevirajmasa.demo.model.Restaurant;
 import com.example.rezevirajmasa.demo.model.TableEntity;
+import com.example.rezevirajmasa.demo.model.exceptions.InvalidRestaurantIdException;
 import com.example.rezevirajmasa.demo.model.exceptions.InvalidTableNumberException;
-import com.example.rezevirajmasa.demo.repository.ReservationRepository;
 import com.example.rezevirajmasa.demo.repository.RestaurantRepository;
 import com.example.rezevirajmasa.demo.repository.TableRepository;
 import com.example.rezevirajmasa.demo.service.TableService;
-import jakarta.persistence.Table;
-import org.modelmapper.ModelMapper;
-import org.openqa.selenium.InvalidArgumentException;
 import org.springframework.cglib.core.Local;
 import org.springframework.stereotype.Service;
@@ -25,5 +18,4 @@
 import java.time.chrono.ChronoLocalDateTime;
 import java.time.format.DateTimeFormatter;
-import java.util.ArrayList;
 import java.util.Iterator;
 import java.util.List;
@@ -33,11 +25,13 @@
     private final TableRepository tableRepository;
     private final RestaurantRepository restaurantRepository;
-    private final ReservationRepository reservationRepository;
-    private ModelMapper modelMapper = new ModelMapper();
 
-    public TableServiceImpl(TableRepository tableRepository, RestaurantRepository restaurantRepository, ReservationRepository reservationRepository) {
+    public TableServiceImpl(TableRepository tableRepository, RestaurantRepository restaurantRepository) {
         this.tableRepository = tableRepository;
         this.restaurantRepository = restaurantRepository;
-        this.reservationRepository = reservationRepository;
+    }
+
+    @Override
+    public TableEntity findById(Long id) {
+        return tableRepository.findById(id).orElseThrow(InvalidTableNumberException::new);
     }
 
@@ -47,34 +41,9 @@
     }
 
-    @Override
-    public TableDTO findById(Long id) {
-        TableEntity table = tableRepository.findById(id)
-                .orElseThrow(InvalidTableNumberException::new);
-
-        TableDTO tableDTO = modelMapper.map(table, TableDTO.class);
-
-        List<ReservationDTO> reservationDTOS = new ArrayList<>();
-        for (Reservation reservation : table.getReservations()) {
-            ReservationDTO reservationDTO = modelMapper.map(reservation, ReservationDTO.class);
-            reservationDTOS.add(reservationDTO);
-        }
-
-        tableDTO.setReservations(reservationDTOS);
-
-        return tableDTO;
-    }
-
-    @Override
-    public TableEntity findByIdTable(Long id) {
-        return tableRepository.findById(id).orElseThrow(() -> new InvalidArgumentException("Invalid table id"));
-    }
-
-
-    @Override
     public void save(int numberOfTables, List<Integer> tableCapacities, List<String> tableLocations, List<String> tableSmokingAreas, List<String> tableDescriptions, Restaurant restaurant) {
         for (int i = 0; i < numberOfTables; i++) {
             TableEntity table = new TableEntity();
             table.setCapacity(tableCapacities.get(i));
-            table.setTableLocation(tableLocations.get(i));
+            table.setLocation(tableLocations.get(i));
             table.setSmokingArea(Boolean.valueOf(tableSmokingAreas.get(i)));
             table.setDescription(tableDescriptions.get(i));
@@ -86,8 +55,13 @@
     @Override
     public void deleteTimeSlotsForReservation(Long tableId, LocalDateTime reservationTime) {
-        TableDTO tableDTO = findById(tableId);
-        TableEntity table = convertFromDTO(tableDTO);
-        LocalDate threeDaysAgo = LocalDate.now().minusDays(3);
-        table.cleanUnusedTimeSlots(threeDaysAgo);
+        LocalDateTime startTime = reservationTime.minusHours(2);
+        LocalDateTime endTime = reservationTime.plusHours(2);
+
+        TableEntity table = findById(tableId);
+        List<LocalDateTime> timeSlots = table.getTimeSlots();
+
+        timeSlots.removeIf(timeSlot -> timeSlot.isAfter(startTime) && timeSlot.isBefore(endTime));
+
+        table.setTimeSlots(timeSlots);
 
         tableRepository.saveAndFlush(table);
@@ -96,31 +70,27 @@
     @Override
     public void canceledTimeSlots(Long tableId, LocalDateTime reservationTime) {
-        TableDTO tableDTO = findById(tableId);
-        TableEntity table = convertFromDTO(tableDTO);
+        TableEntity table = findById(tableId);
+        List<LocalDateTime> timeSlots = table.getTimeSlots();
         LocalDateTime startTime = reservationTime.minusHours(1).minusMinutes(45);
         LocalDateTime endTime = reservationTime.plusHours(1).plusMinutes(45);
 
+        LocalDate localDate = reservationTime.toLocalDate();
+
         String[] hours = table.getRestaurant().getOperatingHours().split("-");
         LocalTime openingHourTime = LocalTime.parse(hours[0], DateTimeFormatter.ofPattern("HH:mm"));
-        LocalDateTime openingHour = openingHourTime.atDate(reservationTime.toLocalDate());
-        LocalDateTime closingHour = LocalTime.of(23, 45).atDate(reservationTime.toLocalDate());
 
-        if (startTime.isBefore(openingHour)) {
-            startTime = openingHour;
+        LocalDateTime openingHour = openingHourTime.atDate(localDate);
+        LocalDateTime closingHour = LocalTime.of(23, 45).atDate(localDate);
+        if(startTime.isBefore(openingHour)) {
+            startTime = LocalDateTime.from(openingHour);
         }
-
-        while (startTime.isBefore(endTime) || startTime.equals(endTime)) {
-            if (startTime.isAfter(closingHour) || startTime.equals(closingHour)) {
+        while(startTime.isBefore(endTime) || startTime.equals(endTime)) {
+            timeSlots.add(startTime);
+            startTime = startTime.plusMinutes(15);
+            if(startTime.isAfter(closingHour) || startTime.equals(closingHour)) {
                 break;
             }
-
-            Reservation reservation = new Reservation();
-            reservation.setReservationDateTime(startTime);
-            reservation.setTable(table);
-            reservationRepository.save(reservation);
-
-            startTime = startTime.plusMinutes(15);
         }
-
+        table.setTimeSlots(timeSlots);
         tableRepository.saveAndFlush(table);
     }
@@ -135,5 +105,4 @@
         return tableRepository.findById(number).orElseThrow(InvalidTableNumberException::new);
     }
-
     @Override
     public TableEntity deleteTable(Long number) {
@@ -147,8 +116,9 @@
         List<TableEntity> tables = tableRepository.findByRestaurant(restaurant);
 
+        // Iterate through each table to check for available time slots
         for (TableEntity table : tables) {
             boolean hasAvailableTimeSlots = hasAvailableTimeSlotsForTableAndDate(table, today);
             if (hasAvailableTimeSlots) {
-                return true;
+                return true; // If any table has available time slots, return true
             }
         }
@@ -158,29 +128,13 @@
 
     public boolean hasAvailableTimeSlotsForTableAndDate(TableEntity table, LocalDate date) {
-        for (Reservation reservation : table.getReservations()) {
-            LocalDateTime startTime = reservation.getReservationDateTime();
-            LocalDateTime endTime = startTime.plusHours(reservation.getTable().getReservationDurationHours());
+        List<LocalDateTime> timeSlots = table.getTimeSlots();
 
-            if (startTime.toLocalDate().equals(date) || endTime.toLocalDate().equals(date)) {
-                return false;
-            }
-        }
-        return true;
+        // Implement your logic to check if the table has available time slots for the given date
+        // This could involve querying the database for reservations for the given table and date,
+        // and checking if there are any open time slots.
+        // You may need to consider factors such as operating hours, existing reservations, etc.
+        // Return true if there are available time slots, false otherwise.
+        return false;
     }
 
-    public RestaurantDTO convertToDto(Restaurant restaurant) {
-        return modelMapper.map(restaurant, RestaurantDTO.class);
-    }
-
-    public TableDTO convertToDto(TableEntity table) {
-        return modelMapper.map(table, TableDTO.class);
-    }
-
-    public ReservationDTO convertToDto(Reservation reservation) {
-        return modelMapper.map(reservation, ReservationDTO.class);
-    }
-
-    public TableEntity convertFromDTO(TableDTO tableDTO) {
-        return modelMapper.map(tableDTO, TableEntity.class);
-    }
 }
Index: src/main/java/com/example/rezevirajmasa/demo/web/controller/CustomerController.java
===================================================================
--- src/main/java/com/example/rezevirajmasa/demo/web/controller/CustomerController.java	(revision d24f17cb212e43f94a77a44d655ba10b4b8143d2)
+++ src/main/java/com/example/rezevirajmasa/demo/web/controller/CustomerController.java	(revision d24f17cb212e43f94a77a44d655ba10b4b8143d2)
@@ -0,0 +1,47 @@
+package com.example.rezevirajmasa.demo.web.controller;
+
+import com.example.rezevirajmasa.demo.model.MembershipLevel;
+import com.example.rezevirajmasa.demo.model.Role;
+import com.example.rezevirajmasa.demo.service.CustomerService;
+import org.springframework.stereotype.Controller;
+import org.springframework.ui.Model;
+import org.springframework.web.bind.annotation.GetMapping;
+import org.springframework.web.bind.annotation.PostMapping;
+import org.springframework.web.bind.annotation.RequestParam;
+
+@Controller
+public class CustomerController {
+    private final CustomerService customerService;
+
+    public CustomerController(CustomerService customerService) {
+        this.customerService = customerService;
+    }
+
+    @GetMapping("/customers")
+    public String showCustomers(Model model) {
+        model.addAttribute("bodyContent", "customers");
+        model.addAttribute("customers", customerService.listAll());
+        model.addAttribute("memberships", MembershipLevel.values());
+        model.addAttribute("roles", Role.values());
+        return "index";
+    }
+    @GetMapping("/customers/add")
+    public String showAddForm(Model model) {
+        model.addAttribute("bodyContent", "CustomersForm");
+        model.addAttribute("memberships", MembershipLevel.values());
+        model.addAttribute("roles", Role.values());
+        return "index";
+    }
+    @PostMapping("/customers/add")
+    public String createCustomer(@RequestParam String firstName,
+                                 @RequestParam String lastName,
+                                 @RequestParam String email,
+                                 @RequestParam String password,
+                                 @RequestParam String phone,
+                                 @RequestParam String address,
+                                 @RequestParam MembershipLevel membershipLevel,
+                                 @RequestParam Role role) {
+        customerService.registration(firstName, lastName, email, password, phone, address, membershipLevel, role);
+        return "redirect:/customers";
+    }
+}
Index: src/main/java/com/example/rezevirajmasa/demo/web/controller/ReservationController.java
===================================================================
--- src/main/java/com/example/rezevirajmasa/demo/web/controller/ReservationController.java	(revision d24f17cb212e43f94a77a44d655ba10b4b8143d2)
+++ src/main/java/com/example/rezevirajmasa/demo/web/controller/ReservationController.java	(revision d24f17cb212e43f94a77a44d655ba10b4b8143d2)
@@ -0,0 +1,95 @@
+package com.example.rezevirajmasa.demo.web.controller;
+
+import com.example.rezevirajmasa.demo.model.*;
+import com.example.rezevirajmasa.demo.model.exceptions.ExpiredReservationException;
+import com.example.rezevirajmasa.demo.service.*;
+import org.springframework.format.annotation.DateTimeFormat;
+import org.springframework.security.core.Authentication;
+import org.springframework.stereotype.Controller;
+import org.springframework.transaction.annotation.RestrictedTransactionalEventListenerFactory;
+import org.springframework.ui.Model;
+import org.springframework.web.bind.annotation.*;
+
+import java.time.LocalDateTime;
+import java.time.LocalTime;
+import java.util.List;
+import java.util.stream.Collectors;
+
+@Controller
+public class ReservationController {
+    private final ReservationService reservationService;
+    private final CustomerService customerService;
+    private final TableService tableService;
+    private final ReservationHistoryService reservationHistoryService;
+
+    public ReservationController(ReservationService reservationService, CustomerService customerService, TableService tableService, ReservationHistoryService reservationHistoryService) {
+        this.reservationService = reservationService;
+        this.customerService = customerService;
+        this.tableService = tableService;
+        this.reservationHistoryService = reservationHistoryService;
+    }
+
+    @GetMapping("/reservations")
+    public String showReservations(Model model, Authentication authentication) {
+        Customer customer = customerService.findByEmail(authentication.getName());
+        List<Reservation> reservationList;
+        if(customer.getRole().equals(Role.ROLE_ADMIN)) {
+            reservationList = reservationService.listAll();
+        } else {
+            reservationList = reservationService.findReservationByCustomer(customer);
+        }
+        model.addAttribute("bodyContent", "reservationList");
+        model.addAttribute("reservations", reservationList);
+        return "index";
+    }
+
+    @GetMapping("/reservations/edit/{reservationId}")
+    public String showEditReservation(@PathVariable Long reservationId, Model model) {
+        Reservation reservation = reservationService.findById(reservationId);
+        tableService.canceledTimeSlots(reservation.getTable().getId(), reservation.getCheckInTime());
+        model.addAttribute("reservation", reservation);
+        model.addAttribute("bodyContent", "reservationsEditForm");
+        return "index";
+    }
+
+    @PostMapping("/restaurants/{tableNumber}")
+    public String saveReservation(@PathVariable Long tableNumber,
+                                  @RequestParam @DateTimeFormat(iso = DateTimeFormat.ISO.DATE_TIME) LocalDateTime reservationDateTime,
+                                  @RequestParam int partySize,
+                                  @RequestParam String specialRequests,
+                                  Authentication authentication){
+        TableEntity table = tableService.findById(tableNumber);
+        Restaurant restaurant = table.getRestaurant();
+
+        Customer customer = customerService.findByEmail(authentication.getName());
+
+        if(!table.isAvailable(reservationDateTime)) {
+            System.out.println("The slot is taken sorry, pick another :D");
+        }
+        tableService.deleteTimeSlotsForReservation(tableNumber, reservationDateTime);
+        reservationService.makeReservation(customer, table, restaurant, LocalDateTime.now(), reservationDateTime, partySize, specialRequests);
+        return "redirect:/reservations";
+    }
+
+    @RequestMapping("/reservations/edit/{reservationId}")
+    public String updateReservation(@PathVariable Long reservationId,
+                                    @RequestParam int partySize,
+                                    @RequestParam String specialRequests,
+                                    @RequestParam @DateTimeFormat(iso = DateTimeFormat.ISO.DATE_TIME) LocalDateTime reservationDateTime) {
+        Reservation reservation = reservationService.findById(reservationId);
+        reservation.setPartySize(partySize);
+        reservation.setSpecialRequests(specialRequests);
+        reservation.setCheckInTime(reservationDateTime);
+        tableService.deleteTimeSlotsForReservation(reservation.getTable().getId(), reservationDateTime);
+        return "redirect:/reservations";
+    }
+
+    @PostMapping("/reservations/delete/{reservationId}")
+    public String deleteReservation(@PathVariable Long reservationId, @RequestParam String reason) {
+        Reservation reservation = reservationService.findById(reservationId);
+        tableService.canceledTimeSlots(reservation.getTable().getId(), reservation.getCheckInTime());
+        reservationService.cancelReservation(reservationId);
+        reservationHistoryService.moveReservationToHistory(reservation, "canceled", reason);
+        return "redirect:/reservation-history";
+    }
+}
Index: src/main/java/com/example/rezevirajmasa/demo/web/controller/ReservationHistoryController.java
===================================================================
--- src/main/java/com/example/rezevirajmasa/demo/web/controller/ReservationHistoryController.java	(revision e48199adf103ea72701a91722bdbf8cfb9732731)
+++ src/main/java/com/example/rezevirajmasa/demo/web/controller/ReservationHistoryController.java	(revision d24f17cb212e43f94a77a44d655ba10b4b8143d2)
@@ -1,11 +1,9 @@
 package com.example.rezevirajmasa.demo.web.controller;
 
-import com.example.rezevirajmasa.demo.dto.SignUpDto;
-import com.example.rezevirajmasa.demo.dto.UserDto;
-import com.example.rezevirajmasa.demo.mappers.UserMapper;
+import com.example.rezevirajmasa.demo.model.Customer;
 import com.example.rezevirajmasa.demo.model.Restaurant;
-import com.example.rezevirajmasa.demo.model.User;
+import com.example.rezevirajmasa.demo.model.Role;
+import com.example.rezevirajmasa.demo.service.CustomerService;
 import com.example.rezevirajmasa.demo.service.ReservationHistoryService;
-import com.example.rezevirajmasa.demo.service.UserService;
 import org.springframework.security.core.Authentication;
 import org.springframework.stereotype.Controller;
@@ -20,11 +18,9 @@
 public class ReservationHistoryController {
     private final ReservationHistoryService reservationHistoryService;
-    private final UserService userService;
-    private final UserMapper userMapper;
+    private final CustomerService customerService;
 
-    public ReservationHistoryController(ReservationHistoryService reservationHistoryService, UserService userService, UserMapper userMapper) {
+    public ReservationHistoryController(ReservationHistoryService reservationHistoryService, CustomerService customerService) {
         this.reservationHistoryService = reservationHistoryService;
-        this.userService = userService;
-        this.userMapper = userMapper;
+        this.customerService = customerService;
     }
 
@@ -32,16 +28,10 @@
     public String showPastReservations(Authentication authentication, Model model) {
         List<Restaurant.ReservationHistory> reservationHistoryList;
-        UserDto userDto = userService.findByEmail(authentication.getName());
-
-        SignUpDto signUpDto = userMapper.toSignUpDto(userDto);
-
-        User user = userMapper.signUpToUser(signUpDto);
-
-        reservationHistoryList = reservationHistoryService.findByUser(user);
-//        if(customer.getRole().equals(Role.ROLE_ADMIN)) {
-//            reservationHistoryList = reservationHistoryService.findAll();
-//        } else {
-//            reservationHistoryList = reservationHistoryService.findByUser(User user);
-//        }
+        Customer customer = customerService.findByEmail(authentication.getName());
+        if(customer.getRole().equals(Role.ROLE_ADMIN)) {
+            reservationHistoryList = reservationHistoryService.findAll();
+        } else {
+            reservationHistoryList = reservationHistoryService.findByCustomer(customer);
+        }
         model.addAttribute("historyReservations", reservationHistoryList);
         model.addAttribute("bodyContent", "pastReservations");
